package domaine;

import domaine.temps.Heure;
import domaine.temps.HeureV2;
import domaine.temps.MauvaisFormatDHeure;
import domaine.temps.MauvaiseValeurDesHeures;
import domaine.temps.MauvaiseValeurDesMinutes;

public class Alarme implements Comparable<Alarme> {
    private Heure quand;
    public Alarme() {
        quand = new HeureV2();
    }
    public Alarme(int h, int m) throws MauvaiseValeurDesHeures, MauvaiseValeurDesMinutes {
        quand = new HeureV2(h, m);
    }
    public Alarme(String heure) throws MauvaisFormatDHeure, MauvaiseValeurDesHeures, MauvaiseValeurDesMinutes {
        quand = new HeureV2(heure);
    }
    public Heure heure() { return quand; }
    public int heures() {
        return quand.heures();
    }
    public int minutes() {
        return quand.minutes();
    }
    public String toString() {
        return quand.toString();
    }
    public int compareTo(Alarme autre) {
        int comparaison = quand.compareTo(autre.quand);
        return comparaison;
    }
}
